package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AuthorizationFaceModel = (*customAuthorizationFaceModel)(nil)

type (
	// AuthorizationFaceModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAuthorizationFaceModel.
	AuthorizationFaceModel interface {
		authorizationFaceModel
	}

	customAuthorizationFaceModel struct {
		*defaultAuthorizationFaceModel
	}
)

// NewAuthorizationFaceModel returns a model for the database table.
func NewAuthorizationFaceModel(conn sqlx.SqlConn, c cache.CacheConf) AuthorizationFaceModel {
	return &customAuthorizationFaceModel{
		defaultAuthorizationFaceModel: newAuthorizationFaceModel(conn, c),
	}
}
