// Code generated by goctl. DO NOT EDIT!

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"time"

	"github.com/Masterminds/squirrel"
	"github.com/pkg/errors"
	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
	"qnc-server/common/globalkey"
)

var (
	authorizationFaceFieldNames          = builder.RawFieldNames(&AuthorizationFace{})
	authorizationFaceRows                = strings.Join(authorizationFaceFieldNames, ",")
	authorizationFaceRowsExpectAutoSet   = strings.Join(stringx.Remove(authorizationFaceFieldNames, "`id`", "`create_time`", "`update_time`"), ",")
	authorizationFaceRowsWithPlaceHolder = strings.Join(stringx.Remove(authorizationFaceFieldNames, "`id`", "`create_time`", "`update_time`"), "=?,") + "=?"

	cacheQncAuthorizationFaceIdPrefix           = "cache:qnc:authorizationFace:id:"
	cacheQncAuthorizationFaceCertifyIdPrefix    = "cache:qnc:authorizationFace:certifyId:"
	cacheQncAuthorizationFaceOuterOrderNoPrefix = "cache:qnc:authorizationFace:outerOrderNo:"
)

type (
	authorizationFaceModel interface {
		Insert(ctx context.Context, session sqlx.Session, data *AuthorizationFace) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*AuthorizationFace, error)
		FindOneByCertifyId(ctx context.Context, certifyId string) (*AuthorizationFace, error)
		FindOneByOuterOrderNo(ctx context.Context, outerOrderNo string) (*AuthorizationFace, error)
		Update(ctx context.Context, session sqlx.Session, data *AuthorizationFace) (sql.Result, error)
		UpdateWithVersion(ctx context.Context, session sqlx.Session, data *AuthorizationFace) error
		Trans(ctx context.Context, fn func(context context.Context, session sqlx.Session) error) error
		SelectBuilder() squirrel.SelectBuilder
		DeleteSoft(ctx context.Context, session sqlx.Session, data *AuthorizationFace) error
		FindSum(ctx context.Context, sumBuilder squirrel.SelectBuilder, field string) (float64, error)
		FindCount(ctx context.Context, countBuilder squirrel.SelectBuilder, field string) (int64, error)
		FindAll(ctx context.Context, rowBuilder squirrel.SelectBuilder, orderBy string) ([]*AuthorizationFace, error)
		FindPageListByPage(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AuthorizationFace, error)
		FindPageListByPageWithTotal(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AuthorizationFace, int64, error)
		FindPageListByIdDESC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AuthorizationFace, error)
		FindPageListByIdASC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AuthorizationFace, error)
		Delete(ctx context.Context, session sqlx.Session, id int64) error
	}

	defaultAuthorizationFaceModel struct {
		sqlc.CachedConn
		table string
	}

	AuthorizationFace struct {
		Id                 int64          `db:"id"`
		AuthorizationId    int64          `db:"authorization_id"` // 关联授权主表ID
		CertifyId          string         `db:"certify_id"`
		OuterOrderNo       string         `db:"outer_order_no"` // 外部业务流水号
		CertifyUrl         string         `db:"certify_url"`
		CertifyUrlExpireAt time.Time      `db:"certify_url_expire_at"` // 认证链接过期时间
		Status             string         `db:"status"`                // 认证状态：pending待认证、success成功、fail失败
		ResultMsg          sql.NullString `db:"result_msg"`
		PdfUrl             sql.NullString `db:"pdf_url"`
		CreateTime         time.Time      `db:"create_time"`
		UpdateTime         time.Time      `db:"update_time"`
		DeleteTime         sql.NullTime   `db:"delete_time"` // 删除时间
		DelState           int64          `db:"del_state"`
		Version            int64          `db:"version"` // 版本号
	}
)

func newAuthorizationFaceModel(conn sqlx.SqlConn, c cache.CacheConf) *defaultAuthorizationFaceModel {
	return &defaultAuthorizationFaceModel{
		CachedConn: sqlc.NewConn(conn, c),
		table:      "`authorization_face`",
	}
}

func (m *defaultAuthorizationFaceModel) Insert(ctx context.Context, session sqlx.Session, data *AuthorizationFace) (sql.Result, error) {
	data.DelState = globalkey.DelStateNo
	qncAuthorizationFaceCertifyIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceCertifyIdPrefix, data.CertifyId)
	qncAuthorizationFaceIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, data.Id)
	qncAuthorizationFaceOuterOrderNoKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceOuterOrderNoPrefix, data.OuterOrderNo)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, authorizationFaceRowsExpectAutoSet)
		if session != nil {
			return session.ExecCtx(ctx, query, data.AuthorizationId, data.CertifyId, data.OuterOrderNo, data.CertifyUrl, data.CertifyUrlExpireAt, data.Status, data.ResultMsg, data.PdfUrl, data.DeleteTime, data.DelState, data.Version)
		}
		return conn.ExecCtx(ctx, query, data.AuthorizationId, data.CertifyId, data.OuterOrderNo, data.CertifyUrl, data.CertifyUrlExpireAt, data.Status, data.ResultMsg, data.PdfUrl, data.DeleteTime, data.DelState, data.Version)
	}, qncAuthorizationFaceCertifyIdKey, qncAuthorizationFaceIdKey, qncAuthorizationFaceOuterOrderNoKey)
}

func (m *defaultAuthorizationFaceModel) FindOne(ctx context.Context, id int64) (*AuthorizationFace, error) {
	qncAuthorizationFaceIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, id)
	var resp AuthorizationFace
	err := m.QueryRowCtx(ctx, &resp, qncAuthorizationFaceIdKey, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", authorizationFaceRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id, globalkey.DelStateNo)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) FindOneByCertifyId(ctx context.Context, certifyId string) (*AuthorizationFace, error) {
	qncAuthorizationFaceCertifyIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceCertifyIdPrefix, certifyId)
	var resp AuthorizationFace
	err := m.QueryRowIndexCtx(ctx, &resp, qncAuthorizationFaceCertifyIdKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) (i interface{}, e error) {
		query := fmt.Sprintf("select %s from %s where `certify_id` = ? and del_state = ? limit 1", authorizationFaceRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, certifyId, globalkey.DelStateNo); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) FindOneByOuterOrderNo(ctx context.Context, outerOrderNo string) (*AuthorizationFace, error) {
	qncAuthorizationFaceOuterOrderNoKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceOuterOrderNoPrefix, outerOrderNo)
	var resp AuthorizationFace
	err := m.QueryRowIndexCtx(ctx, &resp, qncAuthorizationFaceOuterOrderNoKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) (i interface{}, e error) {
		query := fmt.Sprintf("select %s from %s where `outer_order_no` = ? and del_state = ? limit 1", authorizationFaceRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, outerOrderNo, globalkey.DelStateNo); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) Update(ctx context.Context, session sqlx.Session, newData *AuthorizationFace) (sql.Result, error) {
	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return nil, err
	}
	qncAuthorizationFaceCertifyIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceCertifyIdPrefix, data.CertifyId)
	qncAuthorizationFaceIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, data.Id)
	qncAuthorizationFaceOuterOrderNoKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceOuterOrderNoPrefix, data.OuterOrderNo)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, authorizationFaceRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.AuthorizationId, newData.CertifyId, newData.OuterOrderNo, newData.CertifyUrl, newData.CertifyUrlExpireAt, newData.Status, newData.ResultMsg, newData.PdfUrl, newData.DeleteTime, newData.DelState, newData.Version, newData.Id)
		}
		return conn.ExecCtx(ctx, query, newData.AuthorizationId, newData.CertifyId, newData.OuterOrderNo, newData.CertifyUrl, newData.CertifyUrlExpireAt, newData.Status, newData.ResultMsg, newData.PdfUrl, newData.DeleteTime, newData.DelState, newData.Version, newData.Id)
	}, qncAuthorizationFaceCertifyIdKey, qncAuthorizationFaceIdKey, qncAuthorizationFaceOuterOrderNoKey)
}

func (m *defaultAuthorizationFaceModel) UpdateWithVersion(ctx context.Context, session sqlx.Session, newData *AuthorizationFace) error {

	oldVersion := newData.Version
	newData.Version += 1

	var sqlResult sql.Result
	var err error

	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return err
	}
	qncAuthorizationFaceCertifyIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceCertifyIdPrefix, data.CertifyId)
	qncAuthorizationFaceIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, data.Id)
	qncAuthorizationFaceOuterOrderNoKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceOuterOrderNoPrefix, data.OuterOrderNo)
	sqlResult, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ? and version = ? ", m.table, authorizationFaceRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.AuthorizationId, newData.CertifyId, newData.OuterOrderNo, newData.CertifyUrl, newData.CertifyUrlExpireAt, newData.Status, newData.ResultMsg, newData.PdfUrl, newData.DeleteTime, newData.DelState, newData.Version, newData.Id, oldVersion)
		}
		return conn.ExecCtx(ctx, query, newData.AuthorizationId, newData.CertifyId, newData.OuterOrderNo, newData.CertifyUrl, newData.CertifyUrlExpireAt, newData.Status, newData.ResultMsg, newData.PdfUrl, newData.DeleteTime, newData.DelState, newData.Version, newData.Id, oldVersion)
	}, qncAuthorizationFaceCertifyIdKey, qncAuthorizationFaceIdKey, qncAuthorizationFaceOuterOrderNoKey)
	if err != nil {
		return err
	}
	updateCount, err := sqlResult.RowsAffected()
	if err != nil {
		return err
	}
	if updateCount == 0 {
		return ErrNoRowsUpdate
	}

	return nil
}

func (m *defaultAuthorizationFaceModel) DeleteSoft(ctx context.Context, session sqlx.Session, data *AuthorizationFace) error {
	data.DelState = globalkey.DelStateYes
	data.DeleteTime = sql.NullTime{Time: time.Now(), Valid: true}
	if err := m.UpdateWithVersion(ctx, session, data); err != nil {
		return errors.Wrapf(errors.New("delete soft failed "), "AuthorizationFaceModel delete err : %+v", err)
	}
	return nil
}

func (m *defaultAuthorizationFaceModel) FindSum(ctx context.Context, builder squirrel.SelectBuilder, field string) (float64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindSum Least One Field"), "FindSum Least One Field")
	}

	builder = builder.Columns("IFNULL(SUM(" + field + "),0)")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp float64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAuthorizationFaceModel) FindCount(ctx context.Context, builder squirrel.SelectBuilder, field string) (int64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindCount Least One Field"), "FindCount Least One Field")
	}

	builder = builder.Columns("COUNT(" + field + ")")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp int64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAuthorizationFaceModel) FindAll(ctx context.Context, builder squirrel.SelectBuilder, orderBy string) ([]*AuthorizationFace, error) {

	builder = builder.Columns(authorizationFaceRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AuthorizationFace
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) FindPageListByPage(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AuthorizationFace, error) {

	builder = builder.Columns(authorizationFaceRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AuthorizationFace
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) FindPageListByPageWithTotal(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AuthorizationFace, int64, error) {

	total, err := m.FindCount(ctx, builder, "id")
	if err != nil {
		return nil, 0, err
	}

	builder = builder.Columns(authorizationFaceRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, total, err
	}

	var resp []*AuthorizationFace
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, total, nil
	default:
		return nil, total, err
	}
}

func (m *defaultAuthorizationFaceModel) FindPageListByIdDESC(ctx context.Context, builder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AuthorizationFace, error) {

	builder = builder.Columns(authorizationFaceRows)

	if preMinId > 0 {
		builder = builder.Where(" id < ? ", preMinId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id DESC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AuthorizationFace
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) FindPageListByIdASC(ctx context.Context, builder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AuthorizationFace, error) {

	builder = builder.Columns(authorizationFaceRows)

	if preMaxId > 0 {
		builder = builder.Where(" id > ? ", preMaxId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id ASC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AuthorizationFace
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAuthorizationFaceModel) Trans(ctx context.Context, fn func(ctx context.Context, session sqlx.Session) error) error {

	return m.TransactCtx(ctx, func(ctx context.Context, session sqlx.Session) error {
		return fn(ctx, session)
	})

}

func (m *defaultAuthorizationFaceModel) SelectBuilder() squirrel.SelectBuilder {
	return squirrel.Select().From(m.table)
}
func (m *defaultAuthorizationFaceModel) Delete(ctx context.Context, session sqlx.Session, id int64) error {
	data, err := m.FindOne(ctx, id)
	if err != nil {
		return err
	}

	qncAuthorizationFaceCertifyIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceCertifyIdPrefix, data.CertifyId)
	qncAuthorizationFaceIdKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, id)
	qncAuthorizationFaceOuterOrderNoKey := fmt.Sprintf("%s%v", cacheQncAuthorizationFaceOuterOrderNoPrefix, data.OuterOrderNo)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		if session != nil {
			return session.ExecCtx(ctx, query, id)
		}
		return conn.ExecCtx(ctx, query, id)
	}, qncAuthorizationFaceCertifyIdKey, qncAuthorizationFaceIdKey, qncAuthorizationFaceOuterOrderNoKey)
	return err
}
func (m *defaultAuthorizationFaceModel) formatPrimary(primary interface{}) string {
	return fmt.Sprintf("%s%v", cacheQncAuthorizationFaceIdPrefix, primary)
}
func (m *defaultAuthorizationFaceModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary interface{}) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", authorizationFaceRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary, globalkey.DelStateNo)
}

func (m *defaultAuthorizationFaceModel) tableName() string {
	return m.table
}
