package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AuthorizationModel = (*customAuthorizationModel)(nil)

type (
	// AuthorizationModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAuthorizationModel.
	AuthorizationModel interface {
		authorizationModel
	}

	customAuthorizationModel struct {
		*defaultAuthorizationModel
	}
)

// NewAuthorizationModel returns a model for the database table.
func NewAuthorizationModel(conn sqlx.SqlConn, c cache.CacheConf) AuthorizationModel {
	return &customAuthorizationModel{
		defaultAuthorizationModel: newAuthorizationModel(conn, c),
	}
}
